#!/usr/bin/python
# -*- coding: UTF-8 -*-
# vim:set shiftwidth=4 tabstop=4 expandtab textwidth=79:

import sys
import os
import awn
import gtk
import time
import gobject
from subprocess import Popen

os.environ['UBUNTU_MENUPROXY'] = ''


class ContainerApplet(awn.Applet):

    def __init__(self, uid, panel_id):
        awn.Applet.__init__(self, 'indicator-applet', uid, panel_id)
        self.socket = gtk.Socket()
        self.add(self.socket)
        self.connect('realize', self.on_realize)

    def on_realize(self, *args):
        self.plug()
        self.fixsize()

    def reexec(self, *args):
        cmd = '/usr/lib/awn/applets/indicator3-applet/indicator3-applet-helper'
        Popen(['pkill', '-f', cmd]).wait()
        pid = os.fork()
        if pid == 0:
            os.execv(sys.argv[0], sys.argv)
        else:
            os.sys.exit(0)

    def plug(self, *args):
        cmd = '/usr/lib/awn/applets/indicator3-applet/indicator3-applet-helper'
        Popen(['pkill', '-f', cmd]).wait()
        Popen([cmd, str(self.socket.get_id())])

    def fixsize(self):
        screen = gtk.gdk.screen_get_default()
#        screen.connect('size-changed', self.plug)
#        screen.connect('composited-changed', self.plug)
        screen.connect('size-changed', self.reexec)
        screen.connect('composited-changed', self.reexec)
        win = gtk.gdk.window_foreign_new(self.socket.get_id())
        def do(win, i = True):
            x, y, w, h, d = win.get_geometry()
            cx, cy = win.get_deskrelative_origin()
            screenw = gtk.gdk.screen_width()
            if x + w > screenw:
                x = screenw - w
            if cy > 100:
                win.move(x, h/2)
            else:
                win.move(x, 0)
                r = gtk.gdk.Region()
                r.union_with_rect(gtk.gdk.Rectangle(0, 0, w, h/2 + 5))
                win.shape_combine_region(r, 0, 0)
            return i == True or i and i.pop()
        gobject.timeout_add(50, do, win)

def main():
    awn.init(sys.argv[1:])
#    sid = awn.window
#    gobject.timeout_add(10, fixsize, sid)
    time.sleep(1)
    app = ContainerApplet(awn.uid, awn.panel_id)
    awn.embed_applet(app)
    app.show_all()
    gtk.main()

if __name__ == "__main__":
    main()
